/**
 * generated by Xtext 2.27.0
 */
package no.hal.quiz.xtext.generator;

import com.google.common.collect.Iterators;
import java.io.File;
import java.util.ArrayList;
import no.hal.quiz.Quiz;
import no.hal.quiz.html.Quiz2TextGenerator;
import org.eclipse.emf.common.util.BasicMonitor;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class QuizDSLGenerator extends AbstractGenerator {
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    try {
      final Quiz quizRoot = IteratorExtensions.<Quiz>head(Iterators.<Quiz>filter(resource.getAllContents(), Quiz.class));
      final Quiz2TextGenerator generator = new Quiz2TextGenerator();
      String _name = quizRoot.getName();
      String _plus = (_name + ".html");
      fsa.generateFile(_plus, generator.generateHtml(quizRoot));
      final URI modelURI = resource.getURI();
      final File folder = new File("/home/montex/Lavoro/NTNU/Teaching/TDT4250/runtime-EclipseXtext/example/src-gen/acceleo/");
      final ArrayList<String> arguments = new ArrayList<String>();
      final no.hal.quiz.html.acceleo.Quiz2TextGenerator acceleoGen = new no.hal.quiz.html.acceleo.Quiz2TextGenerator(modelURI, folder, arguments);
      BasicMonitor _basicMonitor = new BasicMonitor();
      acceleoGen.doGenerate(_basicMonitor);
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
